Index: /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface/JsonTemplateGenerator.cs
===================================================================
--- /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface/JsonTemplateGenerator.cs	(revision 17827)
+++ /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface/JsonTemplateGenerator.cs	(revision 17828)
@@ -12,11 +12,19 @@
   public class JsonTemplateGenerator {
 
-    public static void GenerateTemplate(string path, IOptimizer optimizer) =>
-      GenerateTemplate(path, optimizer.Name, optimizer);
+    /// <summary>
+    /// static Function to generate a template.
+    /// </summary>
+    /// <param name="templatePath">the path for the template files</param>
+    /// <param name="optimizer">the optimizer object to serialize</param>
+    /// <param name="rootItem">Root JsonItem for serialization, considers only active JsonItems for serialization</param>
+    public static void GenerateTemplate(string templatePath, IOptimizer optimizer, IJsonItem rootItem) {
+      // clear all runs
+      optimizer.Runs.Clear();
 
-    public static void GenerateTemplate(string path, string templateName, IOptimizer optimizer) =>
-      GenerateTemplate(path, templateName, optimizer, JsonItemConverter.Extract(optimizer));
+      // validation
+      ValidationResult validationResult = rootItem.GetValidator().Validate();
+      if (!validationResult.Success)
+        throw validationResult.GenerateException();
 
-    public static void GenerateTemplate(string path, string templateName, IOptimizer optimizer, IJsonItem rootItem) {
       #region Init
       JObject template = JObject.Parse(Constants.Template);
@@ -24,5 +32,7 @@
       JArray resultItems = new JArray();
       IList<IJsonItem> jsonItems = new List<IJsonItem>();
-      string fullPath = Path.GetFullPath(path);
+      string templateName = Path.GetFileName(templatePath);
+      string templateDirectory = Path.GetDirectoryName(templatePath);
+
       #endregion
 
@@ -35,5 +45,5 @@
       #region Serialize HL File
       ProtoBufSerializer serializer = new ProtoBufSerializer();
-      string hlFilePath = Path.Combine(fullPath, templateName + ".hl");
+      string hlFilePath = Path.Combine(templateDirectory, $"{templateName}.hl");
       serializer.Serialize(optimizer, hlFilePath);
       #endregion
@@ -56,5 +66,5 @@
 
       #region Serialize and write to file
-      File.WriteAllText(fullPath + @"\" + templateName + ".json", SingleLineArrayJsonWriter.Serialize(template));
+      File.WriteAllText(Path.Combine(templateDirectory, $"{templateName}.json"), SingleLineArrayJsonWriter.Serialize(template));
       #endregion
     }
Index: /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface/JsonTemplateInstantiator.cs
===================================================================
--- /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface/JsonTemplateInstantiator.cs	(revision 17827)
+++ /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface/JsonTemplateInstantiator.cs	(revision 17828)
@@ -1,3 +1,4 @@
-﻿using System.Collections.Generic;
+﻿using System;
+using System.Collections.Generic;
 using System.IO;
 using System.Linq;
@@ -66,5 +67,8 @@
       IJsonItem rootItem = Objects.First().Value;
 
-      //TODO validate
+      // validation
+      ValidationResult validationResult = rootItem.GetValidator().Validate();
+      if (!validationResult.Success)
+        throw validationResult.GenerateException();
 
       // inject configuration
@@ -105,7 +109,11 @@
         if (Objects.TryGetValue(path, out IJsonItem param)) {
           // remove fixed template parameter from config => dont allow to copy them from concrete config
+          // TODO: shift this into JsonItems?
           obj.Property(nameof(IIntervalRestrictedJsonItem<int>.Minimum))?.Remove();
           obj.Property(nameof(IIntervalRestrictedJsonItem<int>.Maximum))?.Remove();
           obj.Property(nameof(IConcreteRestrictedJsonItem<string>.ConcreteRestrictedItems))?.Remove();
+          obj.Property(nameof(IMatrixJsonItem.ColumnsResizable))?.Remove();
+          obj.Property(nameof(IMatrixJsonItem.RowsResizable))?.Remove();
+          obj.Property(nameof(IArrayJsonItem.Resizable))?.Remove();
           // merge
           param.SetJObject(obj);
Index: /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface/Models/ConcreteRestrictedValueJsonItem.cs
===================================================================
--- /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface/Models/ConcreteRestrictedValueJsonItem.cs	(revision 17827)
+++ /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface/Models/ConcreteRestrictedValueJsonItem.cs	(revision 17828)
@@ -1,7 +1,10 @@
-﻿using System.Collections.Generic;
+﻿using System.Collections;
+using System.Collections.Generic;
 using System.Linq;
 
 namespace HeuristicLab.JsonInterface {
+
   public abstract class ConcreteRestrictedValueJsonItem<T> : ValueJsonItem<T>, IConcreteRestrictedJsonItem<T> {
+
     public IEnumerable<T> ConcreteRestrictedItems { get; set; }
 
Index: /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface/Models/JsonItem.cs
===================================================================
--- /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface/Models/JsonItem.cs	(revision 17827)
+++ /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface/Models/JsonItem.cs	(revision 17828)
@@ -1,3 +1,4 @@
-﻿using System.Collections;
+﻿using System;
+using System.Collections;
 using System.Collections.Generic;
 using System.Linq;
@@ -26,4 +27,7 @@
     public bool Success { get; }
     public IEnumerable<string> Errors { get; }
+
+    public Exception GenerateException() => 
+      new AggregateException(Errors.Select(x => new ArgumentException(x)));
   }
 
@@ -76,5 +80,4 @@
     }
 
-    // TODO jsonIgnore dataType?
     [JsonIgnore]
     public virtual IEnumerable<IJsonItem> Children { get; protected set; }
Index: /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface/Models/ResultJsonItem.cs
===================================================================
--- /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface/Models/ResultJsonItem.cs	(revision 17827)
+++ /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface/Models/ResultJsonItem.cs	(revision 17828)
@@ -2,4 +2,6 @@
   public class ResultJsonItem : JsonItem, IResultJsonItem {
     protected override ValidationResult Validate() => ValidationResult.Successful();
+
+    public string Converter { get; set; }
   }
 }
Index: /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface/Models/UnsupportedJsonItem.cs
===================================================================
--- /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface/Models/UnsupportedJsonItem.cs	(revision 17827)
+++ /branches/3026_IntegrationIntoSymSpace/HeuristicLab.JsonInterface/Models/UnsupportedJsonItem.cs	(revision 17828)
@@ -1,8 +1,10 @@
 ﻿using System;
 using System.Collections.Generic;
+using System.Linq;
 using Newtonsoft.Json;
 
 namespace HeuristicLab.JsonInterface {
   public class UnsupportedJsonItem : JsonItem {
+    /*
     public override string Name {
       get => throw new NotSupportedException();
@@ -10,5 +12,5 @@
     }
 
-    public override string Description {
+    public override string Description { // TODO
       get => throw new NotSupportedException();
       set => throw new NotSupportedException();
@@ -18,11 +20,12 @@
       get => throw new NotSupportedException();
     }
+    */
 
     [JsonIgnore]
     public override IEnumerable<IJsonItem> Children {
-      get => throw new NotSupportedException();
+      get => Enumerable.Empty<IJsonItem>();
       protected set => throw new NotSupportedException();
     }
-
+    /*
     [JsonIgnore]
     public override IJsonItem Parent {
@@ -30,5 +33,5 @@
       set => throw new NotSupportedException();
     }
-
+    */
     protected override ValidationResult Validate() => ValidationResult.Successful();
   }
Index: /branches/3026_IntegrationIntoSymSpace/Heuristiclab.ConfigStarter/Program.cs
===================================================================
--- /branches/3026_IntegrationIntoSymSpace/Heuristiclab.ConfigStarter/Program.cs	(revision 17827)
+++ /branches/3026_IntegrationIntoSymSpace/Heuristiclab.ConfigStarter/Program.cs	(revision 17828)
@@ -48,5 +48,5 @@
 
       
-      JsonTemplateGenerator.GenerateTemplate(@"C:\Workspace\ConfigStarter\", "Template", alg, root);
+      //JsonTemplateGenerator.GenerateTemplate(@"C:\Workspace\ConfigStarter\", "Template", alg, root);
       
 
